/*jslint nomen: true, indent: 2, maxerr: 3, maxlen: 80*/
/*global window, RSVP, rJS, jIO*/
(function(window, RSVP, rJS, jIO) {
  "use strict";

  function dispatchQueue(context, function_used, argument_list, number_queue) {
    var result_promise_list = [],
      i,
      defer;

    function pushAndExecute(global_defer) {
      if ((global_defer.promise.isFulfilled) ||
        (global_defer.promise.isRejected)) {
        return;
      }
      if (argument_list.length > 0) {
        console.log(argument_list.length);
        function_used.apply(context, argument_list.shift())
          .then(function(result) {
            pushAndExecute(global_defer);
          })
          .fail(function(error) {
            console.log(error);
            global_defer.reject(error);
          });
        return;
      }
      global_defer.resolve();
    }
    for (i = 0; i < number_queue; i += 1) {
      defer = RSVP.defer();
      result_promise_list.push(defer.promise);
      pushAndExecute(defer);
    }
    if (number_queue > 1) {
      return RSVP.all(result_promise_list);
    }
    return result_promise_list[0];
  }
  
  rJS(window)

  .declareAcquiredMethod("add", "add")
  .declareAcquiredMethod("add_file", "add_file")

  .declareMethod("concurrent_parse", function(links_file){
    var gadget = this,
      links = new DOMParser().parseFromString(links_file, "text/xml").getElementsByTagName("url"),
      links_modified = [],
      i;
    console.log(file_name + " : " + links.length);
    for (i=0; i<links.length; i+=1){
      links_modified[i] = [links[i].getElementsByTagName('loc')[0].textContent];
    }
    return new RSVP.Queue().push(function() {
      return dispatchQueue(gadget, gadget._get, links_modified, 3);
    })
    .push(function(){
      return gadget.add_file(file_name);
    });
  })

  .declareMethod("_get", function(link){
    var gadget = this;
    return new RSVP.Queue()
      .push(function(){
       var rng = Math.floor(Math.random() * Math.floor(10));
        if (rng % 2 === 0 ) return jIO.util.ajax({url : "https://softinst116265.host.vifib.net/erp5/ERP5Site_getHTTPResource?url=" + link});
        else return jIO.util.ajax({url : "https://softinst116446.host.vifib.net/erp5/ERP5Site_getHTTPResource?url=" + link});
      })
      .push(function(page){
        var item,
          result;
        if (page !== undefined){
          item = new DOMParser().parseFromString(page.currentTarget.response, "text/html");
          result = {
            link : page.currentTarget.responseURL.slice("https://softinst116265.host.vifib.net/erp5/ERP5Site_getHTTPResource?url=".length),
            title : item.title, 
            //description : item.querySelector('meta[name="description"]').getAttribute('content'), 
            description : "",
            item : item.getElementsByTagName("body")[0].innerText
          };
          return gadget.add(result);
        }
      })
      .push(undefined, function (my_error) {console.log(my_error)});
  });

}(window, RSVP, rJS, jIO));
