/*jslint nomen: true, indent: 2, maxerr: 3, maxlen: 80*/
/*global window, RSVP, rJS, jIO*/
(function (window, document, RSVP, rJS, jIO, Rusha) {
 "use strict";
 rJS(window)
 
 .ready(function(){
    var db,
      small_test_map,
      small_test_map_array,
      received_small_test_map,
      small_p_sent,
      small_p_received,
      big_test_map,
      big_test_map_array,
      received_big_test_map,
      big_p_sent,
      big_p_received,
      string_to_array,
      show_results,
      rusha = new Rusha();
    
    db = jIO.createJIO({
      type : "indexeddb",
      database : "test"
    });
   
    show_results = function(){
      small_p_sent = document.createElement('p');
      small_p_sent.innerHTML = "Sent small test map SHA1 : " + rusha.digestFromArrayBuffer(small_test_map_array);
      document.body.appendChild(small_p_sent);
      
      small_p_received = document.createElement('p');
      small_p_received.innerHTML = "Received small test map SHA1 : " + rusha.digestFromArrayBuffer(received_small_test_map);
      document.body.appendChild(small_p_received);
      
      big_p_sent = document.createElement('p');
      big_p_sent.innerHTML = "Sent big test map SHA1 : " + rusha.digestFromArrayBuffer(big_test_map_array);
      document.body.appendChild(big_p_sent);
      
      big_p_received = document.createElement('p');
      big_p_received.innerHTML = "Received big test map SHA1 : " + rusha.digestFromArrayBuffer(received_big_test_map);
      document.body.appendChild(big_p_received);
    };
   
    new RSVP.Queue()
      .push(function(){
        return jIO.util.ajax({url : "small_test_map"});
      })
      .push(function(file_small){
        small_test_map = file_small.currentTarget.responseText;
        return jIO.util.ajax({url : "big_test_map"});
      })
      .push(function(file_big){
        big_test_map = file_big.currentTarget.responseText;
        console.log(big_test_map.length);
        return db.put("test", {});
      })
      .push(function(){
        return jIO.util.readBlobAsArrayBuffer(new Blob([small_test_map]));
      })
      .push(function(small_array){
        small_test_map_array = small_array.target.result;
        return jIO.util.readBlobAsArrayBuffer(new Blob([big_test_map]));
      })
      .push(function(big_array){
        big_test_map_array = big_array.target.result;
        return db.putAttachment("test", "small", new Blob([small_test_map], {type : "text/plain"}));
      })
      .push(function(){
        return db.putAttachment("test", "big", new Blob([big_test_map], {type : "text/plain"}));
      })
      .push(function(){
        return db.getAttachment("test", "small");
      })
      .push(function(received_small_blob){
        console.log("received small");
        return jIO.util.readBlobAsArrayBuffer(received_small_blob);
      })
      .push(function(received_small_array){
        received_small_test_map = received_small_array.target.result;
        return db.getAttachment("test", "big");
      })
      .push(function(received_big_blob){
        console.log("received big");
        return jIO.util.readBlobAsArrayBuffer(received_big_blob);
      })
      .push(function(received_big_array){
        received_big_test_map = received_big_array.target.result;
        show_results();
      })
      .push(undefined, function(error){console.log(error)});
 });
 
}(window, document, RSVP, rJS, jIO, Rusha));